;*****************************************************************************
;  Name         : MSBVPRG.LSP   fuer TRICSY-ST
;  Erstellt     : 30.09.1996
;  Gendert     :
;  Beschreibung : Unterroutinen fr MSBLOCKV.LSP und MSBV.LSP
;
;  nderungen:
;  13.02.97 KST  '' und '' in Windows-Zeichensatz
;  05.03.97 KST ConvertDOStoWIN nach read-line
;  05.03.97 KST ConvertWINtoDOS vor write-line
;  07.03.97 KBO 'ms_help' mit Aufruf 'TRICsy' statt lastpick
;  17.08.99 KBO Klartexte durch die Funktion 'C_GT' (C_GetText) ersetzt
;               Alle Strings gehren in die Datei "TRICSY.GER" oder
;               "TRICSY.ENG" oder "TRICSY.FRA" ...
;  17.04.02 KST Neue Ebene (Gewerk): Get_BlInfo angepasst
;
;*****************************************************************************

(prompt ".")
    (if (= TSY_IS_BRICSCAD 1) (progn
        (setq XRef_Test_Val 100)
    )(progn
        (setq XRef_Test_Val 36)
    ))

(prompt ".")

;********************* UNTERTITEL ZUM BLOCK ERMITTELN ************************
(defun get_blinfo (Blk_FileName / zeile dos tsmb gew grp pg i res bl)

    (newerr "get_blinfo > msbvprg")

    (setq res "")
    (if (= (strcase (substr Blk_FileName 1 (strlen bvsld_dir))) (strcase bvsld_dir)) (progn
        (setq Blk_FileName (substr Blk_FileName (+ (strlen bvsld_dir)2)))
    ))
    (setq gew (substr Blk_FileName 1  8))
    (setq grp (substr Blk_Filename 10 8))
    (setq pg  (substr Blk_Filename 19 8))
    (setq bl  (substr Blk_FileName 28 8))
    (setq fn  (strcat bvsld_dir "\\" gew "\\" grp "\\" pg "\\tsmb.ins"))
    (setq fn  (open fn "r"))
    (setq dos '())
    (setq msbv '())

    (while (setq zeile (read-line fn))
        (setq zeile (C_ConvertDOStoWIN zeile))
        (setq dos  (append dos  (list (substr zeile 1 8))))
        (setq msbv (append msbv (list (substr zeile 10))))
    )
    (setq i 0)
    (repeat (length dos)
        (if (= (nth i dos) bl) (progn
            (setq res (nth i msbv))
        ))
        (setq i (1+ i))
    )
    (setq fn (close fn))
    (olderr)
    (setq res res)
)

;*****************************************************************************

(defun save_mnu (fn dos tsmb)
    ;; 'dos' and 'tsmb' are lists with the numeric directory names
    ;; and the name of the elements in clear text
    (newerr "save_mnu > msbvprg")

    (setq fn (open fn "w"))
    ;; now loop through all list elements
    (mapcar '(lambda (la lb) (write-line (C_ConvertWINtoDOS (strcat la " " lb)) fn)) dos tsmb)
    (setq fn (close fn))
    (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* ELEMENT AUS LISTE ENTFERNEN ***************************
;Parameter: WERT * LISTE
;Return   : NEUE LISTE ODER GLEICHE WENN WERT NICHT GEFUNDEN
;Die Funktion lscht den ersten in der Liste gefundenen Wert WERT.
; (setq li (list "A" "B" "C" "D" "D" "D" "E" "F" "G"))
; (setq li (del_elem_liste D li))
; ret (A B C D D E F G)

(defun del_elem_liste (elem l_liste / ret e n ok)

   ;(princ "del_elem_l_liste\n")
    (newerr "del_elem_liste > msbvprg")

    (setq n    0)
    (setq ret '())
    (setq ok   nil)

    (while (< n (length l_liste))
        (if (equal (setq e (nth n l_liste)) elem) (progn
            (if ok (progn
                (setq ret (append ret (list e)))
            )(progn
                ;; this is the first occurence of the element
                (setq ok T)
            ))
        )(progn
            (setq ret (append ret (list e)))
        ))
        (setq n (1+ n))
    )
    (olderr)
    (setq ret ret)
)
;*****************************************************************************
(prompt ".")
;********************* ALLGEMEINE HILFE **************************************
; Parameter: keine
; Rckgabe : keine
(defun ms_help ()
     (newerr "ms_help > msbvprg")
     (c_help)
    ; (acad_helpdlg bvhelp_file "tricsy")
     (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* DIA ZOOMEN ********************************************

(defun ms_zoom (Dialog_Selector block_name l_label msg / x y ret)

    (newerr "ms_zoom > msbvprg")

    (if (not (new_dialog (strcat "zoom" Dialog_Selector) $TRIC_DCL_ID$)) (progn
         (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
         (olderr)
         (exit)
    ))
    (setq x (dimx_tile "icon"))
    (setq y (dimy_tile "icon"))
    (start_image "icon")
    (fill_image 0 0 x y -2)
    (slide_image 0 0 x y block_name)
    (end_image)
    (mode_tile "icon" 1)
    (set_tile "datnam" (strcat block_name ".DWG"))
    (set_tile "msg"    (strcat (get_blinfo block_name) " " msg))
    (set_tile "l_label"  l_label)
    (action_tile "help" "(ms_help)")
    (if (= (start_dialog) 1)
        (setq ret T)
    )

    (olderr)
    (setq lastpick "msbv_allgemein")
    (setq ret ret)
)

;*****************************************************************************
(prompt ".")
;********************* ERRPOINT SETZEN ***************************************
;Parameter: keine
;Return   : NIL
(defun newerr (err / ret)
    (setq o_errpoint errpoint)
    (setq errpoint   err)
    (setq ret        nil)
)

;*****************************************************************************
(prompt ".")
;********************* ERRPOINT ZURCKSETZEN *********************************
;Parameter: keine
;Return   : NIL
(defun olderr ( / ret)
    (setq errpoint o_errpoint)
    (setq ret nil)
)


;*****************************************************************************
(prompt ".")
;********************* SYSTEMVARIABLEN RESTAURIEREN **************************

(defun rest_setvar()

    (newerr "rest_setvar > msbvprg")

    (setvar "expert"  o_expert)
    (setvar "attreq"  o_attreq)
   ;; (setvar "pdmode"  o_pdmode)
    (setvar "cecolor" o_cecolor)
   ; (setvar "osmode"  o_osmode)
    (setvar "clayer"  o_clayer)
    (command "._undo" "_e")
    (setvar "cmdecho" o_cmdecho)
    (setq   *error*   old_err)
)

;*****************************************************************************
(prompt ".")
;********************* LISTE AUS DATEI GENERIEREN ****************************
; Arguments:
;    Path and Name of the file to be red
;    (normaly ...\TSMB.INS or ...\TSMB.DIR)
; Returns:
;    A List consisting of two lists :
;          SubList1 :   List of DOS names for the blocks
;          SubList2 :   List of block names as labels

(defun gen_liste (fn / dos msbv zeile)

  (newerr "gen_liste > msbvprg")

  ; (alert (strcat "Gen_Liste -> " fn))
  (setq dos '() msbv '())
  (if (setq fn (open fn "r")) (progn
      (while (setq zeile (read-line fn))
          (setq zeile (C_ConvertDOStoWIN zeile))
          (setq dos  (append dos  (list (substr zeile 1 8))))
          (setq msbv (append msbv (list (substr zeile 10))))
      )
      (setq fn (close fn))
  ))
  (olderr)
  (cons dos msbv)
)


;*****************************************************************************
(prompt ".")
;********************* ALLGEMEINER FRAGEDIALOG *******************************
; Parameter: (STR) Meldung
; Rckgabe : (BOOL) T wenn OK ; nil wenn CANCEL gedrckt wurde
(defun ms_ask (msg / ret)

    (newerr "ms_ask > msbvprg")

    (if (not (new_dialog "ms_ask0" $TRIC_DCL_ID$)) (progn
         (alert (strcat "Fehler in <" bvdcl_file ">"))
         (olderr)
         (exit)
    ))
    (set_tile "l_label" (C_GT "S_CONFIRMATION"))
    (set_tile "msg"   msg)
    (action_tile "help" "(c_help)")
    (setq ret (start_dialog))
    (set_tile "msg" (C_GT "SELECT_FUNCTION"))
    (olderr)
    (if (= ret 1) T nil)
)

;*****************************************************************************
(prompt ".")
;********************* ALLGEMEINER HINWEISDIALOG *****************************
; Parameter: (STR) Meldung
; Rckgabe : (BOOL) T wenn OK ; nil wenn CANCEL gedrckt wurde
(defun ms_msg (msg / ret)

    (newerr "ms_msg > msbvprg")

    (if (not $TRIC_DCL_ID$) (progn
        (setq $TRIC_DCL_ID$ (load_dialog bvdcl_file))
    ))
    (if (new_dialog "ms_msg0" $TRIC_DCL_ID$) (progn
        (set_tile "l_label" (c_gt "S_INFORMATION"))
        (set_tile "msg" msg)
        (setq ret (start_dialog))
    )(progn
        (alert (strcat (C_GT "ERR_LOAD_DCL_1") bvdcl_file (C_GT "ERR_LOAD_DCL_2")))
        (olderr)
        (exit)
    ))
    (set_tile "msg" (C_GT "SELECT_FUNCTION"))
    (olderr)
    (if (= ret 1) (progn
        (setq ret T)
    )(progn
        (setq ret nil)
    ))
)

;*****************************************************************************
(prompt ".")
;********************* POPUP- UND SLIDELISTEN ESTELLEN ********************************
(defun make_list (var1 var2)

    (newerr "make_list > msbvprg")

    (start_list var1)
    (mapcar 'add_list var2)
    (end_list)
    (olderr)
)

;*****************************************************************************
(prompt ".")
;********************* DOS COMMAND *******************************************
(defun ms_shell (dos_command)

    (C_Shell dos_command)
)

;*****************************************************************************
(prompt ".")
;********************* VERZEICHNIS ANLEGEN ***********************************
(defun dir_exist (dir fn); DIR=VERZEICHNIS, FN=INHALTS-DATEI

    (newerr "dir_exist > msbvprg")
    (if (not (findfile fn)) (progn
        ;WENN VERZEICHNIS NICHT VORHANDEN, ANLEGEN
        (C_MakeDir dir)
        (setq fn (open fn "w") fn (close fn))
    ))
    (olderr)
)

;;*****************************************************************************
(if $Verbose$ (princ "\nArj_Present"))
;;********************* Testen, ob ARJ.EXE ************************************
(defun Arj_Present ( / Datei ret)
    (setq Datei (strcase (findfile (strcat bvprog_dir "\\ARJ32.EXE"))))
    ; findfile sucht den OS-Path ab, deshalb muessen wir mit
    ; dem Programm-Pfad vergleichen
    (if (= Datei (strcase (strcat bvprog_dir "\\ARJ32.EXE"))) (progn
        (setq ret "1")
    )(progn
        (setq ret "0")
    ))
    (setq ret ret)
) ; test_arj


;*****************************************************************************
(prompt ".")
; (xload (strcat bvprog_dir "\\MSBVSUB"))
(prompt ".")
